/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
dt.misc = {
    dmSetup: function () {
        var dtPkeys = [];
        var dtTkeys = [];
        for (var i = 0; i < localStorage.length; i++) {
            var k = localStorage.key(i);
            var kBits = k.split(":");
            if (kBits.length > 1) {
                if (kBits[0] == PlayerId) {
                    dtPkeys.push(k);
                }
                if (dt[PlayerId].towns.list.includes(kBits[0])) {
                    dtTkeys.push(k)
                }
            }
        }
        dtTkeys.sort();
        var kda = document.querySelector("#dtDataManagerHTML div.kda");
        kda.innerHTML = "<h3>Player Data</h3>";
        for (i = 0; i < dtPkeys.length; i++) {
            var p = document.createElement("p");
            p.textContent = dtPkeys[i];
            kda.appendChild(p);
        }
        var p = document.createElement("h3");
        p.textContent = "Town Data";
        kda.appendChild(p);
        for (i = 0; i < dtTkeys.length; i++) {
            var p = document.createElement("p");
            p.textContent = dtTkeys[i];
            kda.appendChild(p);
        }
        document.querySelector("fieldset.dda > textArea").textContent = "";
        dt.showTool("#dtDataManagerHTML");
    },
    showData: function (event) {
        var t = event.target;
        console.log(event);
        var dda = document.querySelector("#dtDataManagerHTML fieldset.dda");
        dda.innerHTML = "";
        var tmp = document.createElement("legend");
        tmp.textContent = t.textContent;
        dda.appendChild(tmp);
        tmp = document.createElement("textArea");
        dda.appendChild(tmp);
        var d = localStorage.getItem(t.textContent);
        tmp.innerHTML = d;
        dt.currentData = t.textContent;
        console.log(t.txtContent);
    },
    copyData: function () {
        var copyTextarea = document.querySelector("fieldset.dda > textArea");
        copyTextarea.focus();
        copyTextarea.select();

        try {
            var successful = document.execCommand('copy');
            var msg = successful ? 'successful' : 'unsuccessful';
            console.log('Copying text command was ' + msg);
        } catch (err) {
            console.log('Oops, unable to copy');
        }
    },
    clearData: function(){
        localStorage.removeItem(dt.currentData);
    },

    addCanvas: function(){
        var dtCanvases = {
            "notes":{"id":"mapNotes","class":dt[PlayerId].mapDisplay.noteDisplay},
            "tenSq":{"id":"tenSq","class":dt[PlayerId].mapDisplay.tenSq},
            "fiveSq":{"id":"fiveSq","class":dt[PlayerId].mapDisplay.fiveSq}
        };
        var canvases = Object.keys(dtCanvases);
        for(i=0;i<canvases.length;i++){
//        var canvas = document.getElementById('mapNotes');
        var canvas = document.getElementById(dtCanvases[canvases[i]].id);
        if(!canvas){
            var p = document.querySelector("#mapDiv");
            canvas = document.createElement("canvas");
//            canvas.setAttribute("id","mapNotes");
            canvas.setAttribute("id",dtCanvases[canvases[i]].id);
            // <canvas id="mapNotes" width="500" height="500" style="position:absolute;top:11px;left:15px;" unselectable="on"></canvas>
            canvas.setAttribute("width","500");
            canvas.setAttribute("height","500");
            canvas.setAttribute("style","position:absolute;top:11px;left:15px;");
            canvas.setAttribute("unselectable","on");
//            canvas.setAttribute("class",dt[PlayerId].mapDisplay.noteDisplay);
            canvas.setAttribute("class",dtCanvases[canvases[i]].class);
            p.appendChild(canvas);
        }
        dt.ctx = canvas.getContext('2d');
        dt.ctx.clearRect(0, 0, 500, 500);
        }    

    },
    
    gmBeepToggle: function(){
        
      var currentState = document.querySelector("#gmBeepToggle").textContent;
      var rd = document.querySelector("#gmBeepToggle");
      if(currentState == "Enable GM Beep"){
          rd.textContent = "Disable GM Beep";
          dt[PlayerId].gmBeep = true;
      }else{
          rd.textContent = "Enable GM Beep";
          dt[PlayerId].gmBeep = false;
          
      }
        GMbeep=dt[PlayerId].gmBeep;
       locStorage.setItem(PlayerId + ":GMBeep", JSON.stringify(dt[PlayerId].gmBeep));
      var rubbish = "";

    },
	/* Method: regions
	 * Display the dialog showing the list of regions in the game.
	 * @returns {undefined}
	 */
	regions: function () {
		dt.showTool("#regionsHtml");
	},
	showTourneySqs: function(){
        var tourneySqs = {
        "1":{"id":"61","X":"-728", "Y":"-2433", "Region":"Aindara", "terrain": "Plains","Biome":""},
                "2":{"id":"67","X":"-111", "Y":"-2677", "Region":"Almenly", "terrain": "Small Forest","Biome":""},
                "3":{"id":"25","X":"46", "Y":"-597", "Region":"Arran", "terrain": "Plains","Biome":"Jungle"},
                "4":{"id":"29","X":"-218", "Y":"-476", "Region":"Azura", "terrain": "Large Forest","Biome":"Jungle"},
                "5":{"id":"40","X":"447", "Y":"-2850", "Region":"Calumnex", "terrain": "Large Forest","Biome":""},
                "6":{"id":"74","X":"-819", "Y":"-3169", "Region":"Chulbran", "terrain": "Plains","Biome":""},
                "7":{"id":"45","X":"130", "Y":"-1577", "Region":"Clarien", "terrain": "Small Forest","Biome":""},
                "8":{"id":"57","X":"-571", "Y":"-2009", "Region":"Coanhara", "terrain": "Plains","Desert":""},
                "9":{"id":"30","X":"767", "Y":"-701", "Region":"Djebeli", "terrain": "Large Forest","Biome":"Jungle"},
                "10":{"id":"28","X":"769", "Y":"-372", "Region":"Elijal", "terrain": "Plains","Biome":"Desert"},
                "11":{"id":"35","X":"-523", "Y":"-866", "Region":"Farra Isle", "terrain": "Plains","Biome":""},
                "12":{"id":"71","X":"923", "Y":"-2658", "Region":"Farshards", "terrain": "Plains","Biome":""},
                "13":{"id":"64","X":"829", "Y":"-2322", "Region":"Fellandire", "terrain": "Plains","Biome":""},
                "14":{"id":"8","X":"-876", "Y":"376", "Region":"Fremorn", "terrain": "Plains","Biome":""},
                "15":{"id":"49","X":"99", "Y":"-1813", "Region":"Glanhad", "terrain": "Large Forest","Biome":""},
                "16":{"id":"56","X":"816", "Y":"-2224", "Region":"Gremont", "terrain": "Small Forest","Biome":""},
                "17":{"id":"51","X":"608", "Y":"-1793", "Region":"High Hills", "terrain": "Small Hill","Biome":""},
                "18":{"id":"44","X":"-737", "Y":"-1682", "Region":"Huronire", "terrain": "Small Forest","Biome":"Jungle"},
                "19":{"id":"75","X":"563", "Y":"-3101", "Region":"Jurgor", "terrain": "Large Forest","Biome":""},
                "20":{"id":"2","X":"-410", "Y":"481", "Region":"Kal Tirikan", "terrain": "Small Hill","Biome":""},
                "21":{"id":"34","X":"627", "Y":"-843", "Region":"Kem", "terrain": "Plains","Biome":"Jungle"},
                "22":{"id":"17","X":"-505", "Y":"94", "Region":"Keppen", "terrain": "Plains","Biome":""},
                "23":{"id":"20","X":"783", "Y":"-264", "Region":"Keshalia", "terrain": "Small Mountain","Biome":"Jungle"},
                "24":{"id":"70","X":"-726", "Y":"-2692", "Region":"Kingslands", "terrain": "Plains","Biome":""},
                "25":{"id":"68","X":"-555", "Y":"-2444", "Region":"Kormandly", "terrain": "Large Hill","Biome":""},
                "26":{"id":"22","X":"993", "Y":"-354", "Region":"Kul Tar", "terrain": "Plains","Biome":"Desert"},
                "27":{"id":"23","X":"-985", "Y":"-481", "Region":"Kumala", "terrain": "Plains","Biome":"Jungle"},
                "28":{"id":"24","X":"-507", "Y":"-407", "Region":"Lan Larosh", "terrain": "Plains","Biome":""},
                "29":{"id":"10","X":"917", "Y":"189", "Region":"Laoshin", "terrain": "Plains","Biome":""},
                "30":{"id":"58","X":"911", "Y":"-2035", "Region":"Lapo'a Lua", "terrain": "Large Forest","Biome":""},
                "31":{"id":"33","X":"669", "Y":"-705", "Region":"Larn", "terrain": "Plains","Biome":"Jungle"},
                "32":{"id":"14","X":"318", "Y":"81", "Region":"Lucerna", "terrain": "Plains","Biome":""},
                "33":{"id":"16","X":"654", "Y":"98", "Region":"Mal Motsha", "terrain": "Small Hill","Biome":""},
                "34":{"id":"13","X":"-334", "Y":"397", "Region":"Meilla", "terrain": "Plains","Biome":""},
                "35":{"id":"15","X":"151", "Y":"182", "Region":"Middle Kingdom", "terrain": "Large Forest","Biome":""},
                "36":{"id":"59","X":"109", "Y":"-2266", "Region":"Newlands", "terrain": "Small Forest","Biome":""},
                "37":{"id":"50","X":"-625", "Y":"-1856", "Region":"Northmarch", "terrain": "Plains","Biome":"Desert"},
                "38":{"id":"9","X":"-198", "Y":"474", "Region":"Norweld", "terrain": "Plains","Biome":""},
                "39":{"id":"54","X":"-255", "Y":"-2044", "Region":"Oarnamly", "terrain": "Large Hill","Biome":""},
                "40":{"id":"43","X":"-207", "Y":"-1497", "Region":"Pamanyallpa", "terrain": "Small Hill","Biome":"Jungle"},
                "41":{"id":"46","X":"328", "Y":"-1584", "Region":"Pawanallpa", "terrain": "Plains","Biome":"Desert"},
                "42":{"id":"21","X":"254", "Y":"-310", "Region":"Perrigor", "terrain": "Plains","Biome":""},
                "43":{"id":"41","X":"49", "Y":"-1391", "Region":"Puchuallpa", "terrain": "Large Forest","Biome":"Jungle"},
                "44":{"id":"5","X":"807", "Y":"677", "Region":"Qarosslan", "terrain": "Small Forest","Biome":""},
                "45":{"id":"11","X":"541", "Y":"329", "Region":"Ragallon", "terrain": "Plains","Biome":""},
                "46":{"id":"37","X":"-661", "Y":"-886", "Region":"Rill Archipelago", "terrain": "Small Mountain","Biome":"Jungle"},
                "47":{"id":"72","X":"180", "Y":"-2920", "Region":"Shardlands", "terrain": "Large Mountain","Biome":""},
                "48":{"id":"63","X":"-289", "Y":"-2278", "Region":"Silbeaur", "terrain": "Large Forest","Biome":""},
                "49":{"id":"38","X":"-19", "Y":"-989", "Region":"Stormstone Island", "terrain": "Plains","Biome":"Jungle"},
                "50":{"id":"73","X":"-583", "Y":"-3010", "Region":"Strendur", "terrain": "Large Hill","Biome":""},
                "51":{"id":"32","X":"-232", "Y":"-651", "Region":"Tallimar", "terrain": "Plains","Biome":"Jungle"},
                "52":{"id":"7","X":"671", "Y":"473", "Region":"Tamarin", "terrain": "Plains","Biome":""},
                "53":{"id":"12","X":"577", "Y":"318", "Region":"Taomist", "terrain": "Small Mountain","Biome":""},
                "54":{"id":"76","X":"-269", "Y":"-3290", "Region":"The Long White", "terrain": "Large Hill","biome":"Arctic"},
                "55":{"id":"69","X":"280", "Y":"-2579", "Region":"The Orken Coast", "terrain": "Large Forest","Biome":""},
                "56":{"id":"62","X":"164", "Y":"-2463", "Region":"The Pirate Isles", "terrain": "Large Hill","Biome":""},
                "57":{"id":"48","X":"-891", "Y":"-1586", "Region":"The Poisoned Isle", "terrain": "Small Hill","Biome":"Jungle"},
                "58":{"id":"1","X":"-971", "Y":"717", "Region":"The Wastes", "terrain": "Plains","Biome":""},
                "59":{"id":"19","X":"-802", "Y":"51", "Region":"The Western Realms", "terrain": "Plains","Biome":""},
                "60":{"id":"18","X":"29", "Y":"-169", "Region":"Tor Carrock", "terrain": "Large Forest","Biome":""},
                "61":{"id":"36","X":"443", "Y":"-928", "Region":"Trome", "terrain": "Plains","Biome":"Jungle"},
                "62":{"id":"26","X":"343", "Y":"-540", "Region":"Turalia", "terrain": "Plains","Biome":""},
                "63":{"id":"4","X":"436", "Y":"765", "Region":"Ursor", "terrain": "Large Hill","Biome":""},
                "64":{"id":"66","X":"315", "Y":"-2594", "Region":"Vindorel", "terrain": "Plains","Biome":""},
                "65":{"id":"52","X":"-768", "Y":"-1832", "Region":"Westmarch", "terrain": "Plains","Biome":""},
                "66":{"id":"6","X":"514", "Y":"612", "Region":"Windlost", "terrain": "Plains","Biome":""},
                "67":{"id":"3","X":"303", "Y":"985", "Region":"Wolgast", "terrain": "Large Forest","Biome":""},
                "68":{"id":"27","X":"603", "Y":"-578", "Region":"Zanpur", "terrain": "Plains","Biome":""}
        }

        var okeys = Object.keys(tourneySqs);
        tbdy = document.querySelector("#tSqsData tbody");
        dt.removeRows(document.querySelector("#tSqsData"))

        for (var thisSq in okeys){
            var coordString = "";
            var coordArray = [];
            var newRow = tbdy.insertRow( - 1);
            var newCell = newRow.insertCell(0);
            newCell.textContent = tourneySqs[okeys[thisSq]].Region;
            newCell = newRow.insertCell(1);
            // http://tournament.bestmagicbears.com/illy_tournaments.cgi?tid=3&x=46&y=-597
            coordString = '<span><a onclick="href=&quot;#/World/Map/' + tourneySqs[okeys[thisSq]].X + '/' + tourneySqs[okeys[thisSq]].Y + '&quot;">' + tourneySqs[okeys[thisSq]].X + '|' + tourneySqs[okeys[thisSq]].Y + '</a></span>';
            newCell.innerHTML = coordString;
            newCell = newRow.insertCell(2);
            newCell.textContent = tourneySqs[okeys[thisSq]].terrain;
            newCell = newRow.insertCell(3);
            newCell.textContent = tourneySqs[okeys[thisSq]].Biome;
            
            var sourceC=[parseInt(dt[PlayerId].towns[CurrentTown].x),parseInt(dt[PlayerId].towns[CurrentTown].y)];
            var destC=[parseInt(tourneySqs[okeys[thisSq]].X),parseInt(tourneySqs[okeys[thisSq]].Y)];
            var dist = dt.hypot(sourceC,destC);
            newCell=newRow.insertCell(4);
            newCell.textContent=parseInt(dist);
            newCell=newRow.insertCell(5);
            // https://elgea.illyriad.co.uk/#/World/TournamentSquare/61
            //http://tournament.bestmagicbears.com/illy_tournaments.cgi?tid=3&x=46&y=-597
            //onclick="window.open(&quot;http://battlecalculator.dewt.me.uk/&quot;, &quot;_blank&quot;)
            var ls = "http://tournament.bestmagicbears.com/illy_tournaments.cgi?tid=3&x="+tourneySqs[okeys[thisSq]].X+"&y="+tourneySqs[okeys[thisSq]].Y;
            linkString = '<span><a target="_blank" href="'+ls+'">Cbt Details</a></span>';
            newCell.innerHTML = linkString;
            
        }
        dt.showTool("#tourneySqs");
	},
	cbtmods: function () {
		dt.showTool("#terrainCbtModsHtml");
	},
	/* Method: showUnits
	 * Display the icons for all units available in the game. Data is drawn directly 
	 * from the game (Items[5]). The icons are made into links that open up the same 
	 * popup as in-game by setting the same classes and data attribute as is done 
	 * in-game.
	 * 
	 */
	showUnits: function () {
		var parent = document.querySelector('#imgholder');
		parent.innerHTML = '';
		var keys = Object.keys(Items[5]);
		for (i = 1; i < keys.length; i++) {
			var dat = 'i=5|' + keys[i];
			var newSpan = dt.addElement('', parent, 'span', ['data', 'class', 'title'], [dat, "name " + Items[5][keys[i]][2], Items[5][keys[i]][1] + " (i=5|" + keys[i] + ")"]);
			var newImg = dt.addElement('', newSpan, 'img', ['title', 'src'], [Items[5][keys[i]][1] + ' [@i=5|' + keys[i] + ']', '//assets.illyriad.net/img/icons/' + Items[5][keys[i]][2]]);
			newSpan = dt.addElement('', parent, 'span', ['data', 'class', 'title'], [dat, "name " + Items[5][keys[i]][3], Items[5][keys[i]][1] + " (i=5|" + keys[i] + ")"]);
			var newImg = dt.addElement('', newSpan, 'img', ['title', 'src'], [Items[5][keys[i]][1] + ' [@i=5|' + keys[i] + ']', '//assets.illyriad.net/img/icons/' + Items[5][keys[i]][3]]);
		}
		dt.showTool("#unitsHtml");
		dt.adjustTool("#unitsHtml");

	},
	/* Method: showIcons
	 * Show all the various item icons used in-game.  Data is drawn directly 
	 * from the game (Items[5]). The icons are made into links that open up the same 
	 * popup as in-game by setting the same classes and data attribute as is done 
	 * in-game.
	 * 
	 */
	showIcons: function () {
//	var swp2 = {"1": '3|1', "2": '3|2', "3": '3|3', "4": '3|4', "5": '3|5', "6": '3|6', "7": '3|7', "8": '3|8', "9": '3|9', "10": '3|10', "11": '3|11', "12": '3|12', "17": '1|1', "19": '1|2', "21": '1|3', "23": '1|4', "25": '1|5', "183": '4|1', "295": '2|1', "296": '2|2'};
//	var swp = ['3|1', '3|2', '3|3', '3|4', '3|5', '3|6', '3|7', '3|8', '3|9', '3|10', '3|11', '3|12', '1|1', '1|2', '1|3', '1|4', '1|5', '4|1', '2|1', '2|2'];
		var out = document.querySelector('#icoholder');
		var keys = Object.keys(cp);
		out.innerHTML = '';
		for (var i = 0; i < keys.length; i++) {
			var tt = cp[keys[i]].n + " (cp=" + keys[i] + ")";
//		if(swp2.hasOwnProperty(keys[i])){
//		if (i < 21) {
//			var dat = 'i=' + swp2[keys[i]];
//		} else {
			var dat = 'c=' + keys[i];
//		}
			var newSpan = dt.addElement('',out, 'span', ['data', 'class', 'title'], [dat, "name " + cp[keys[i]].is, cp[keys[i]].n + " [@c=" + keys[i] + "]"]);
			newSpan = dt.addElement('',out, 'span', ['data', 'class', 'title'], [dat, "name " + cp[keys[i]].il, cp[keys[i]].n + " [@c=" + keys[i] + "]"]);
		}
		dt.showTool("#iconsHtml");
		dt.adjustTool("#iconsHtml");
	},
	groupSizes: function(){
		// 
		dt.showTool("#npcGroupSizesHtml");
	},
};

